#include	<string.h>
#include	"TJsonValue.h"

// cl -GX TJsonValue.cpp

/**
 * RXgN^
 */
TJsonValue::TJsonValue()
{
	value = NULL;
	type = TJsonValue::UNKNOWN_TYPE;
	subType = TJsonValue::UNKNOWN_SUB_TYPE;
}

/**
 * fXgN^
 */
TJsonValue::~TJsonValue()
{
	if (value != NULL) {
		delete []value;
	}
	
	for (unsigned int i = 0;i < arrayValue.size();i++) {
		if (arrayValue[i] != NULL) {
			delete arrayValue[i];
		}
	}

	for (OBJECT_MAP::iterator it = objectValueMap.begin();it != objectValueMap.end();it++) {
		TJsonValue *objectValue = it->second;
		if (objectValue != NULL) {
			delete objectValue;
		}
	}
}

/**
 * lݒ肷B
 *
 * @param newValue Vl
 */
void TJsonValue::setValue(const char *newValue)
{
	if (value != NULL) {
		delete []value;
		value = NULL;
	}

	if (newValue == NULL) {
		return;
	}
	int len = strlen(newValue);

	try {
		value = new char[len + 1];
		if (value == NULL) {
			return;
		}
		strcpy(value,newValue);
	} catch(...) {
		return;
	}
}

/**
 * z̒lǉB
 *
 * @return NULL:Vl NULL:l̒ǉɎs
 */
TJsonValue *TJsonValue::addArrayValue(void)
{

	try {
		TJsonValue *newValue = new TJsonValue();
		if (newValue == NULL) {
			return NULL;
		}
		arrayValue.push_back(newValue);
		return newValue;
	} catch(...) {
		return NULL;
	}
}

/**
 * IuWFNg̒lǉB
 *
 * @return NULL:Vl NULL:l̒ǉɎs
 */
TJsonValue *TJsonValue::addObjectValue(std::string key)
{
	try {
		TJsonValue *newValue = new TJsonValue();
		if (newValue == NULL) {
			return NULL;
		}
		objectValueMap.insert(object_value(key,newValue));
		return newValue;
	} catch(...) {
		return NULL;
	}
}

/**
 * IuWFNg̒l擾B
 *
 * @param key IuWFNg̃L[
 * @return NULL:擾l NULL:l݂͑Ȃ
 */
TJsonValue *TJsonValue::getObjectValue(std::string key)
{
	OBJECT_MAP::iterator gotValue;

	gotValue = objectValueMap.find(key);
	if (gotValue != objectValueMap.end()) {
		return gotValue->second;
	}
	return NULL;
}

/**
 * IuWFNg̒l擾B
 *
 * @param index IuWFNg̃CfbNX
 * @return NULL:擾l NULL:l݂͑Ȃ
 */
TJsonValue *TJsonValue::getObjectValue(int index)
{
	int count = getObjectCount();
	if (index >= count) {
		return NULL;
	}
	std::map<std::string,TJsonValue *>::iterator it = objectValueMap.begin();
	for (int i = 0; i < count; i++) {
		if (i == index) {
			return it->second;
		}
		it++;
	}

	return NULL;
}

/**
 * IuWFNg̒l擾B
 *
 * @param index IuWFNg̃CfbNX
 * @return NULL:擾l NULL:l݂͑Ȃ
 */
std::string TJsonValue::getObjectKey(int index)
{
	int count = getObjectCount();
	if (index >= count) {
		return NULL;
	}
	std::map<std::string,TJsonValue *>::iterator it = objectValueMap.begin();
	for (int i = 0; i < count; i++) {
		if (i == index) {
			return it->first;
		}
		it++;
	}

	return NULL;
}
