#include "stdafx.h"
#include "shellapi.h"

#include "BookSyncApp.h"
#include "BookmarkSelect.h"

/**
 * R{{bNX\Ǝۂ̃ubN}[N̎ނ̑Ή
 */
static int menuNo[SELECTABLE_BOOKMARKS] = {
	// Firefox 3ȍ~̃ubN}[N1
	BOOKMARK_FIREFOX_1,
	// Firefox 3ȍ~̃ubN}[N2
	BOOKMARK_FIREFOX_2,
	// IẼubN}[N
	BOOKMARK_IE,
	// ChromẽubN}[N1
	BOOKMARK_CHROME_1,
	// ChromẽubN}[N2
	BOOKMARK_CHROME_2,
	// Opera 15`28̃Xs[h_C
	BOOKMARK_OPERA15_1,
	// Opera 15`28̃Xs[h_C
	BOOKMARK_OPERA15_2,
	// Opera 25ȍ~̃ubN}[N1
	BOOKMARK_OPERA25_1,
	// Opera 25ȍ~̃ubN}[N2
	BOOKMARK_OPERA25_2,
	// MozillãubN}[N1
	BOOKMARK_MOZILLA_1,
	// MozillãubN}[N2
	BOOKMARK_MOZILLA_2,
	// XBEL`ubN}[N1
	BOOKMARK_XBEL_1,
	// XBEL`ubN}[N2
	BOOKMARK_XBEL_2,
	// Opera 12ȑÕubN}[N1
	BOOKMARK_OPERA_1,
	// Opera 12ȑÕubN}[N2
	BOOKMARK_OPERA_2,
	// SafarĩubN}[N1
	BOOKMARK_SAFARI_1,
	// SafarĩubN}[N2
	BOOKMARK_SAFARI_2
};

/**
 * RXgN^
 *
 * @param parent eEChEnh
 * @param resource _CAO\[X
 */
CBookmarkSelect::CBookmarkSelect(HWND parent, int resource) : BaseDialog(parent, resource)
{
	m_BrowserSelection = NULL;
}

/**
 * fXgN^
 */
CBookmarkSelect::~CBookmarkSelect()
{
	if (m_BrowserSelection != NULL) {
		delete m_BrowserSelection;
	}
}

/**
 * f[^XV
 *
 * @param toObj true:Rg[IuWFNg false:IuWFNgRg[
 */
void CBookmarkSelect::UpdateData(bool toObj)
{
	DDX_CBIndex(toObj, IDC_COMBOBOOKMARK, selection);
}

/**
 * _CAO
 *
 * @return tH[JX̐ݒ肪(FALSE:)
 */
INT_PTR CBookmarkSelect::OnInitDialog()
{
	HWND comboBoxHandle = ::GetDlgItem(hWnd, IDC_COMBOBOOKMARK);

	m_BrowserSelection = new TwrCombobox(comboBoxHandle);

	for (int i = 0; i < SELECTABLE_BOOKMARKS; i++){
		m_BrowserSelection->addItem(bookmark_name[menuNo[i]]);
	}

	UpdateData(false);
	if (title.length() > 0) {
		::SetWindowText(hWnd, title.c_str());
	}
	SetFocus(m_BrowserSelection->getHwnd());

	return (INT_PTR)FALSE;
}

/**
 * WM_COMMANDbZ[W̏
 *
 * @param wParam WPARAM
 */
INT_PTR CBookmarkSelect::OnCommand(WPARAM wParam)
{
	switch (LOWORD(wParam)) {
		case IDOK:
			OnBnClickedOk();
			break;
	}
	return BaseDialog::OnCommand(wParam);
}

/**
 * OK{^̏
 */
void CBookmarkSelect::OnBnClickedOk()
{
	UpdateData(true);
}

/**
 * Iڂ̐ݒ
 *
 * @param no I鍀(ubN}[Nʔ)
 */
void CBookmarkSelect::setSelection(int no)
{
	selection = 0;

	if (no > -1) {
		// ubN}[NʔԂR{{bNX̕\ʒuɒB
		for (int i = 0; i < SELECTABLE_BOOKMARKS; i++) {
			if (no == menuNo[i]) {
				selection = i;
				break;
			}
		}
	}
	UpdateData(false);
}

/**
 * Iڂ̎擾
 *
 * @return I鍀(ubN}[Nʔ)
 */
int CBookmarkSelect::getSelection(void)
{
	return menuNo[selection];
}
