#include "stdafx.h"
#include "shellapi.h"

#include "BookSyncApp.h"
#include "BrowserSelect.h"

/**
 * Xg\Ǝۂ̃ubN}[N̎ނ̑Ή
 * ҏWΏۃubN}[N_CAOƂ邱Ƃ͈ꏏA
 * ҏWΏۂɂȂubN}[NoɔĕʓrzpӂB
 */
static int listNo[SELECTABLE_BOOKMARKS] = {
	// Firefox 3ȍ~̃ubN}[N1
	BOOKMARK_FIREFOX_1,
	// Firefox 3ȍ~̃ubN}[N2
	BOOKMARK_FIREFOX_2,
	// IẼubN}[N
	BOOKMARK_IE,
	// ChromẽubN}[N1
	BOOKMARK_CHROME_1,
	// ChromẽubN}[N2
	BOOKMARK_CHROME_2,
	// Opera 15`28̃Xs[h_C
	BOOKMARK_OPERA15_1,
	// Opera 15`28̃Xs[h_C
	BOOKMARK_OPERA15_2,
	// Opera 25ȍ~̃ubN}[N1
	BOOKMARK_OPERA25_1,
	// Opera 25ȍ~̃ubN}[N2
	BOOKMARK_OPERA25_2,
	// MozillãubN}[N1
	BOOKMARK_MOZILLA_1,
	// MozillãubN}[N2
	BOOKMARK_MOZILLA_2,
	// XBEL`ubN}[N1
	BOOKMARK_XBEL_1,
	// XBEL`ubN}[N2
	BOOKMARK_XBEL_2,
	// Opera 12ȑÕubN}[N1
	BOOKMARK_OPERA_1,
	// Opera 12ȑÕubN}[N2
	BOOKMARK_OPERA_2,
	// SafarĩubN}[N1
	BOOKMARK_SAFARI_1,
	// SafarĩubN}[N2
	BOOKMARK_SAFARI_2
};

/**
 * RXgN^
 *
 * @param parent eEChEnh
 * @param resource _CAO\[X
 */
CBrowserSelect::CBrowserSelect(HWND parent, int resource) : BaseDialog(parent, resource)
{
	m_fromList = NULL;
	m_toList = NULL;
	windowTitle = _T("");
	fromCheckStatus = NULL;
}

/**
 * fXgN^
 */
CBrowserSelect::~CBrowserSelect()
{
	if (m_fromList != NULL) {
		delete m_fromList;
	}
	if (m_toList != NULL) {
		delete m_toList;
	}
}

/**
 * _CAO
 *
 * @return tH[JX̐ݒ肪(FALSE:)
 */
INT_PTR CBrowserSelect::OnInitDialog()
{
	HWND listViewHandle = ::GetDlgItem(hWnd, IDC_LISTSELECT);
	HWND toListViewHandle = ::GetDlgItem(hWnd, IDC_LIST_CONVERT_TO);

	m_fromList = new TwrListView(listViewHandle);
	m_toList = new TwrListView(toListViewHandle);

	setListviewInfo(m_fromList, fromChecked);
	setListviewInfo(m_toList, toChecked);

	// EChE^CgύXB
	const TCHAR *newTitle = windowTitle.c_str();
	setText(newTitle);

	// ŏ̃tH[JXݒ
	m_fromList->selectItem(0);
	SetFocus(m_fromList->getHwnd());

	return (INT_PTR)FALSE;
}

/**
 * WM_COMMANDbZ[W̏
 *
 * @param wParam WPARAM
 */
INT_PTR CBrowserSelect::OnCommand(WPARAM wParam)
{
	switch (LOWORD(wParam)) {
		case IDOK:
			// e`FbN{bNX̏ԂcheckedɔfB
			for (int i = 0;i < SELECTABLE_BOOKMARKS;i++){
				fromChecked[listNo[i]] = m_fromList->isChecked(i);
				toChecked[listNo[i]] = m_toList->isChecked(i);
			}
			break;
	}
	return BaseDialog::OnCommand(wParam);
}

/**
 * Xgr[̏ݒ肷B
 *
 * @param target ݒΏۂListview
 * @param checkStatus ݒ肷`FbN
 */
void CBrowserSelect::setListviewInfo(TwrListView *target, bool *checkStatus)
{
	// Listview̃X^Cݒ
	LONG style = GetWindowLong(target->getHwnd(), GWL_STYLE);
	style = style | LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT;
	if (style & LVS_SORTASCENDING) {
		style ^= LVS_SORTASCENDING;
	}
	if (style & LVS_SORTDESCENDING) {
		style ^= LVS_SORTDESCENDING;
	}

	SetWindowLong(target->getHwnd(), GWL_STYLE, style);
	target->SetExtendedStyle(LVS_EX_CHECKBOXES | LVS_EX_FULLROWSELECT);

	RECT rect;
	GetClientRect(target->getHwnd(), &rect);

	target->insertColumn(0,"w肷ubN}[N",LVCFMT_LEFT,rect.right - rect.left,-1);

	// \ubN}[N̖̂ݒ肷B
	for (int i = 0;i < SELECTABLE_BOOKMARKS;i++){
		target->insertItem(i, bookmark_name[listNo[i]]);
		if (checkStatus[listNo[i]]) {
			target->checkItem(i, true);
		}
	}

}

/**
 * ϊ̃`FbN󋵂ݒ肷B<br>
 * (EChE\OɌĂяoƁB)
 *
 * @param status `FbN
 */
void CBrowserSelect::setFromCheckStatus(bool *status)
{

	for (int i = 0;i < ALL_BOOKMARKS;i++){
		fromChecked[i] = status[i];
	}
}

/**
 * ϊ̃`FbN󋵂ݒ肷B<br>
 * (EChE\OɌĂяoƁB)
 *
 * @param status `FbN
 */
void CBrowserSelect::setToCheckStatus(bool *status)
{

	for (int i = 0;i < ALL_BOOKMARKS;i++){
		toChecked[i] = status[i];
	}
}
