#ifndef OPERAFORM_H
#define OPERAFORM_H

#include "BaseDialog.h"
#include "tstring.h"

class COperaForm : public BaseDialog {
private:
	TwrWnd *editOpera1;
	TwrWnd *editOpera2;
	TwrWnd *chkOpera1;
	TwrWnd *chkOpera2;
	TwrWnd *ignoreTrash1;
	TwrWnd *ignoreTrash2;
	TwrWnd *mobileFormat1;
	TwrWnd *mobileFormat2;
	TwrWnd *syncMobile1;
	TwrWnd *syncMobile2;

	int setBookmarkQuestion(HWND hWnd,TCHAR *target,const TCHAR *path,int no);
	tstring GetOpera6Bookmark();
	tstring GetOperaXXBookmark(TCHAR *version);
	tstring GetOpera10Bookmark(TCHAR *version);
	tstring getOperaBookmarkName(const TCHAR *prefFile);
	tstring GetOperaBasePath(void);
	tstring GetOpera7SingleBookmark(void);
	tstring GetOpera10SingleBookmark(void);
	tstring CheckOperaBookmark(HWND hWnd,int no);

	void OnBnClickedRefopera1();
	void OnBnClickedRefopera2();
	void OnBnClickedButtonsearchop1();
	void OnBnClickedButtonsearchop2();
	void OnBnClickedCheckopera1();
	void OnBnClickedCheckopera2();

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);
public:
	// OperãubN}[N1
	tstring m_OperaBM1;
	// OperãubN}[N2
	tstring m_OperaBM2;
	// OperãubN}[N𓯊邩ǂ(1)
	BOOL m_chkOpera1;
	// OperãubN}[N𓯊邩ǂ(2)
	BOOL m_chkOpera2;
	// Opera 7ȍ~p̏o͂sǂ(1)
	BOOL m_chkOpera7_1;
	// Opera 7ȍ~p̏o͂sǂ(2)
	BOOL m_chkOpera7_2;
	// OperãS~𖳎邩ǂ(1)
	BOOL m_Opera7Trash1;
	// OperãS~𖳎邩ǂ(2)
	BOOL m_Opera7Trash2;
	// Windows Mobileł̃ubN}[Nǂ(1)
	BOOL m_WinMobile1;
	// Windows Mobileł̃ubN}[Nǂ(2)
	BOOL m_WinMobile2;
	// oĈCɓƓ邩ǂ(1)
	BOOL m_SyncMobileFavorites1;
	// oĈCɓƓ邩ǂ(2)
	BOOL m_SyncMobileFavorites2;

	COperaForm(HWND parent, int resource);
	~COperaForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchOpera(HWND hWnd);
	void searchOpera2(HWND hWnd);
};

#endif // OPERAFORM_H

