#ifndef	UTIL_H
#define UTIL_H

#include "BookSyncApp.h"

#include "FxForm.h"
#include "OperaForm.h"
#include "IEForm.h"
#include "SfForm.h"
#include "ChForm.h"
#include "MozForm.h"
#include "XbForm.h"
#include "Op15Form.h"
#include "Op19Form.h"

#include "Configuration.h"
#include "tstring.h"

// MozillañEChENX
#define MOZCLASS _T("MozillaWindowClass")
#define SEAMONKEYCLASS _T("MozillaUIWindowClass")

// ChromeñEChENX
#define CHROMECLASS _T("Chrome_XPFrame")
#define CHROMEVISTACLASS _T("Chrome_VistaFrame")
#define CHROME2CLASS _T("Chrome_WidgetWin_0")

// euEU̎st@C
#define MOZILLA_FILENAME _T("mozilla")
#define FIREFOX_FILENAME _T("firefox")
#define NETSCAPE9_FILENAME _T("navigator")
#define NETSCAPE8_FILENAME _T("netscape")
#define NETSCAPE7_FILENAME _T("Netscp")
#define NETSCAPE6_FILENAME _T("netscp6")
#define PHOENIX_FILENAME _T("phoenix")
#define MOZILLAFIREBIRD_FILENAME _T("MozillaFirebird")
#define SEAMONKEY_FILENAME _T("seamonkey")

#define CHROME_FILENAME _T("chrome")
#define CHROMIUM_FILENAME _T("chromium")
#define IRON_FILENAME _T("iron")
#define DRAGON_FILENAME _T("dragon")

#define OPERA_FILENAME _T("opera")

#define IE7_LINK_NAME "Links"		// IE7̃No[tH_(p)
#define IE7_LINK_NAME_W L"Links"		// IE7̃No[tH_(p)
#define IE7_LINK_NAME_JP "N"	// IE7̃No[tH_({)
#define IE7_LINK_NAME_JP_W L"N"	// IE7̃No[tH_({)

BOOL CALLBACK checkMozillaWindow(HWND hwnd,LPARAM lparam);
BOOL CALLBACK checkChromeWindow(HWND hwnd,LPARAM lparam);
BOOL CALLBACK checkOperaWindow(HWND hwnd,LPARAM lparam);
void setupAutoComplete();
void cleanupAutoComplete();
void setAutoComplete(HWND hWnd);


void mozFormToConfig(Configuration *config,CMozForm *mozForm);
void operaFormToConfig(Configuration *config,COperaForm *operaForm);
void ieFormToConfig(Configuration *config,CIEForm *ieForm);
void fxFormToConfig(Configuration *config,CFxForm *fxForm);
void sfFormToConfig(Configuration *config,CSfForm *sfForm);
void chFormToConfig(Configuration *config,CChForm *chForm);
void xbFormToConfig(Configuration *config,CXbForm *xbForm);
void op15FormToConfig(Configuration *config,COp15Form *op15Form);
void op19FormToConfig(Configuration *config,COp19Form *op19Form);

tstring setBasePath(tstring bookmark);
bool isExistingFile(const TCHAR *filename);

extern int MozillaFoundFlag;
extern int ChromeFoundFlag;
extern int OperaFoundFlag;

#endif	// UTIL_H