#ifndef MOZFORM_H
#define MOZFORM_H

#include "BaseDialog.h"
#include "tstring.h"

class CMozForm : public BaseDialog {
private:
	TwrWnd *editMoz1;
	TwrWnd *editMoz2;
	TwrWnd *chkMoz1;
	TwrWnd *chkMoz2;
	TwrWnd *ignoreIE1;
	TwrWnd *ignoreIE2;
	TwrWnd *ns4Format1;
	TwrWnd *ns4Format2;

	tstring GetMozFireBookmark(HWND hWnd,TCHAR *appProfile,int type,int pos);
	tstring getMozFireProfile(
		HWND hWnd,
		const TCHAR *profileDir,
		const TCHAR *appProfile,
		const TCHAR *profiles,
		const TCHAR *section,
		int type,
		int pos);
	void OnBnClickedRefmoz1();
	void OnBnClickedRefmoz2();
	void OnBnClickedButtonsearchfx1();
	void OnBnClickedButtonsearchfx2();

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);
public:
	// MozillãubN}[N1
	tstring m_MozBM1;
	// MozillãubN}[N2
	tstring m_MozBM2;
	// MozillãubN}[N1s邩ǂ
	BOOL m_chkMoz1;
	// MozillãubN}[N2s邩ǂ
	BOOL m_chkMoz2;
	// IÊCɓ𖳎邩ǂ(1)
	BOOL m_chkIEfav1;
	// IÊCɓ𖳎邩ǂ(2)
	BOOL m_chkIEfav2;
	// ubN}[NNetscape 4`ɂ邩ǂ(1)
	BOOL m_chkNS4Format1;
	// ubN}[NNetscape 4`ɂ邩ǂ(2)
	BOOL m_chkNS4Format2;

	CMozForm(HWND parent, int resource);
	~CMozForm();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchFx1(HWND hWnd);
	void searchFx2(HWND hWnd);
};

#endif // MOZFORM_H

