#ifndef OP15FORM_H
#define OP15FORM_H

#include "BaseDialog.h"
#include "tstring.h"

#define STABLE_BOOKMARK "\\Opera Software\\Opera Stable\\favorites.db"
#define NEXT_BOOKMARK "\\Opera Software\\Opera Next\\favorites.db"
#define DEVELOPER_BOOKMARK "\\Opera Software\\Opera Developer\\favorites.db"

class COp15Form : public BaseDialog {
private:
	TwrWnd *editOp15_1;
	TwrWnd *editOp15_2;
	TwrWnd *chkOp15_1;
	TwrWnd *chkOp15_2;
	TwrWnd *inFolderOp15_1;
	TwrWnd *inFolderOp15_2;
	TwrWnd *optimizeOp15_1;
	TwrWnd *optimizeOp15_2;

	tstring GetBookmark(TCHAR *path);

	void OnBnClickedButtonsearchOp15_1();
	void OnBnClickedButtonsearchOp15_2();
	void OnBnClickedRefOp15_1();
	void OnBnClickedRefOp15_2();
	bool confirm(HWND hWnd,tstring &bookmark,int pos, int type);

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_Op15BM1;
	// ubN}[Ñt@C2
	tstring m_Op15BM2;
	BOOL m_chkOp15_1;
	BOOL m_chkOp15_2;
	// tH_ɃtH_邩ǂ1
	BOOL m_chkInFolder1;
	// tH_ɃtH_邩ǂ2
	BOOL m_chkInFolder2;
	// œK邩ǂ1
	BOOL m_chkOptimize1;
	// œK邩ǂ2
	BOOL m_chkOptimize2;

	COp15Form(HWND parent, int resource);
	~COp15Form();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchOp15_1(HWND hWnd);
	void searchOp15_2(HWND hWnd);

};

#endif // OP15FORM_H

