#ifndef OP19FORM_H
#define OP19FORM_H

#include "BaseDialog.h"
#include "tstring.h"
#include "TwrCombobox.h"

#define OP19_STABLE_BOOKMARK "\\Opera Software\\Opera Stable\\Bookmarks"
#define OP19_NEXT_BOOKMARK "\\Opera Software\\Opera Next\\Bookmarks"
#define OP19_DEVELOPER_BOOKMARK "\\Opera Software\\Opera Developer\\Bookmarks"

class COp19Form : public BaseDialog {
private:
	TwrWnd *editOp19_1;
	TwrWnd *editOp19_2;
	TwrWnd *chkOp19_1;
	TwrWnd *chkOp19_2;
	TwrWnd *chkOp19Trash_1;
	TwrWnd *chkOp19Trash_2;
	TwrWnd *inFolderOp19_1;
	TwrWnd *inFolderOp19_2;

	tstring GetBookmark(TCHAR *path);

	void OnBnClickedButtonsearchOp19_1();
	void OnBnClickedButtonsearchOp19_2();
	void OnBnClickedRefOp19_1();
	void OnBnClickedRefOp19_2();
	bool confirm(HWND hWnd,tstring &bookmark,int pos, int type);

protected:
	INT_PTR OnInitDialog();
	INT_PTR OnCommand(WPARAM wParam);

public:
	// ubN}[Ñt@C1
	tstring m_Op19BM1;
	// ubN}[Ñt@C2
	tstring m_Op19BM2;
	BOOL m_chkOp19_1;
	BOOL m_chkOp19_2;
	// Opera 30̃S~𖳎邩ǂ(1)
	BOOL m_Opera19Trash1;
	// Opera 30̃S~𖳎邩ǂ(2)
	BOOL m_Opera19Trash2;
	// tH_ɃtH_邩ǂ1
	BOOL m_chkInFolder1;
	// tH_ɃtH_邩ǂ2
	BOOL m_chkInFolder2;

	COp19Form(HWND parent, int resource);
	~COp19Form();
	void UpdateData(bool toObj);
	void setSettingEnable(void);

	void searchOp19_1(HWND hWnd);
	void searchOp19_2(HWND hWnd);

};

#endif // OP19FORM_H

