#include "resource.h"
#include "Progress.h"

CProgress::CProgress(HWND parent, int resource) : BaseDialog(parent, resource)
{
	m_Progress = NULL;
}

CProgress::~CProgress()
{
	if (m_Progress != NULL) {
		delete m_Progress;
	}
}

INT_PTR CProgress::OnInitDialog()
{
	HWND progressBarHandle = ::GetDlgItem(hWnd, IDC_PROGRESS1);

	m_Progress = new TwrProgress(progressBarHandle);

	// UpdateData(false);

	return (INT_PTR)FALSE;
}

INT_PTR CProgress::OnCommand(WPARAM wParam)
{
	switch (LOWORD(wParam)) {
		case IDC_CONVERT_CANCEL:
			OnBnClickedConvertCancel();
			return (INT_PTR)TRUE;
	}
	return BaseDialog::OnCommand(wParam);
}

void CProgress::OnBnClickedConvertCancel()
{
	// LZ{^ꂽLZB
	// setCancel(true);
}
