#ifndef MOZILLAWRITER_H
#define MOZILLAWRITER_H

#include	<stdio.h>
#include "Bookmark.h"
#include "MozillaBookmark.h"
#include "IBookmarkWriter.h"

class MozillaWriter : public IBookmarkWriter {
private:
	int m_spaces;	// ݂̃Xy[X̌
	bool m_UTF8;	// UTF-8ǂH
	FILE *cs_fpo;	// ubN}[No͗pt@C|C^
	char *urlBuf;

	// o͌`
	int m_outputType;			// 0:Netscape 4/1:Netscape 6,7/Mozilla(R}hCŐݒ肳ꂽo͑ΏۃuEU)/2:Mozilla Firefox(\)
	// ǂݍ񂾃ubN}[N̎
	int m_mozVersion;	// 0:Netscape 4/1:Netscape 6,7/Mozilla/2:Mozilla 1.4(ǂݎΏۃuEŨo[W)/3:Mozilla Firefox 1.0 and later
	// ݑΏۂ̑
	int m_target;
	// ݂̊Kwx(0`)
	int m_level;
	// IẼNtH_
	char *ieLinkFolderName;
	// IẼNtH_Ƀp[\ic[o[tH_킹邩ǂ
	bool syncIElinkFolder;
	// IE̖Oɂ킹邩ǂ
	bool ieName;
	bool placesPut;	// Firefox 3̃X}[gubN}[NtH_o͂邩ǂH

	void spput(FILE *fp,int spaces);
	void putname(FILE *fp,wchar_t *name);
	void putname2(FILE *fp,char *name);
	void putDescription(FILE *fp,char *name);
	void putShortcut(FILE *fp,char *name);


public:
	/* ubN}[No̓C^[tFCXCvg */
	void putHeader(void);
	void putFolder(Bookmark *item);
	void putFolderEnd(Bookmark *item,bool isLast);
	void putBookmark(Bookmark *item,bool isLast);
	void putFooter(void);

	/* o͌`̎擾Ǝw */
	int getBrowserType(void) { return m_outputType; };
	void setBrowserType(int type){ m_outputType = type;};

	/* ǂݍłubN}[N̎ނ̎w */
	int getBrowserVersion(void){ return m_mozVersion;};
	void setBrowserVersion(int type){ m_mozVersion = type;};

	// ubN}[No͗pt@C|C^ݒ
	void setFilePointer(FILE *fpo) {cs_fpo = fpo;};

	// ݑΏۑ̐ݒ
	int getTarget(void) {return m_target;};
	void setTarget(int target) {m_target = target;};

	// IẼNtH_̐ݒ
	void setIElinkFolderName(char *name){
		ieLinkFolderName = name;
	}

	// IẼNtH_Ƀp[\ic[o[tH_킹邩ǂ̐ݒ
	void setSyncIElinkFolder(bool mode){
		syncIElinkFolder = mode;
	}

	// IE̖Oɂ킹邩ǂ̐ݒ(Windows VistãNtH_Ŏgp)
	void setIEname(bool mode){
		ieName = mode;
	}

	void setPlacesPut(bool mode) {
		placesPut = mode;
	}

	MozillaWriter(void);
	~MozillaWriter();
};

#endif	// MOZILLAWRITER_H
